Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,149 @@
+/*
+ * AllAtomsInsideCuboidAction.cpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "Descriptors/AtomShapeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "Shapes/ShapeOps.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAllAtomsInsideCuboidState : public ActionState {
+public:
+  SelectionAllAtomsInsideCuboidState(std::vector<atom*> _selectedAtoms, const Vector &_position, const Vector &_extension, const double _Xangle, const double _Yangle, const double _Zangle) :
+    selectedAtoms(_selectedAtoms),
+    position(_position),
+    extension(_extension),
+    Xangle(_Xangle),
+    Yangle(_Yangle),
+    Zangle(_Zangle)
+  {}
+  std::vector<atom*> selectedAtoms;
+  Vector position;
+  Vector extension;
+  double Xangle;
+  double Yangle;
+  double Zangle;
+};
+
+const char SelectionAllAtomsInsideCuboidAction::NAME[] = "select-atoms-inside-cuboid";
+
+SelectionAllAtomsInsideCuboidAction::SelectionAllAtomsInsideCuboidAction() :
+  Action(NAME)
+{}
+
+SelectionAllAtomsInsideCuboidAction::~SelectionAllAtomsInsideCuboidAction()
+{}
+
+void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension) {
+  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideCuboidAction::NAME, extension);
+  ValueStorage::getInstance().setCurrentValue("position", position);
+  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
+};
+
+void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle) {
+  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideCuboidAction::NAME, extension);
+  ValueStorage::getInstance().setCurrentValue("position", position);
+  ValueStorage::getInstance().setCurrentValue("angle-x", Xangle);
+  ValueStorage::getInstance().setCurrentValue("angle-y", Yangle);
+  ValueStorage::getInstance().setCurrentValue("angle-z", Zangle);
+  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAllAtomsInsideCuboidAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAllAtomsInsideCuboidAction::performCall() {
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+  Vector position;
+  Vector extension;
+  double Xangle = 0.;
+  double Yangle = 0.;
+  double Zangle = 0.;
+  Matrix RotationMatrix;
+
+  ValueStorage::getInstance().queryCurrentValue("position", position);
+  ValueStorage::getInstance().queryCurrentValue(NAME, extension);
+  // check whether a rotation is given.
+  if (ValueStorage::getInstance().queryCurrentValue("angle-x", Xangle, true))
+    Xangle = 0.;
+  if (ValueStorage::getInstance().queryCurrentValue("angle-y", Yangle, true))
+    Yangle = 0.;
+  if (ValueStorage::getInstance().queryCurrentValue("angle-z", Zangle, true))
+    Zangle = 0.;
+  RotationMatrix.rotation(Xangle, Yangle, Zangle);
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << position << " and extension of " << extension << "." << endl);
+  Shape s = translate(transform(stretch(Cuboid(),extension),RotationMatrix),position);
+  World::getInstance().selectAllAtoms(AtomByShape(s));
+  return Action::state_ptr(new SelectionAllAtomsInsideCuboidState(selectedAtoms, position, extension, Xangle, Yangle, Zangle));
+}
+
+Action::state_ptr SelectionAllAtomsInsideCuboidAction::performUndo(Action::state_ptr _state) {
+  SelectionAllAtomsInsideCuboidState *state = assert_cast<SelectionAllAtomsInsideCuboidState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionAllAtomsInsideCuboidAction::performRedo(Action::state_ptr _state){
+  SelectionAllAtomsInsideCuboidState *state = assert_cast<SelectionAllAtomsInsideCuboidState*>(_state.get());
+  Matrix RotationMatrix;
+
+  RotationMatrix.rotation(state->Xangle, state->Yangle, state->Zangle);
+  Shape s = translate(transform(stretch(Cuboid(),state->extension),RotationMatrix),state->position);
+  World::getInstance().selectAllAtoms(AtomByShape(s));
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionAllAtomsInsideCuboidAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllAtomsInsideCuboidAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAllAtomsInsideCuboidAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,39 @@
+/*
+ * AllAtomsInsideCuboidAction.hpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ALLATOMSINSIDECUBOIDACTION_HPP_
+#define ALLATOMSINSIDECUBOIDACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class Vector;
+
+void SelectionAllAtomsInsideCuboid();
+
+class SelectionAllAtomsInsideCuboidAction : public Action {
+  friend void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension);
+  friend void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle);
+
+public:
+  SelectionAllAtomsInsideCuboidAction();
+  virtual ~SelectionAllAtomsInsideCuboidAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ALLATOMSINSIDECUBOIDACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,119 @@
+/*
+ * AllAtomsInsideSphereAction.cpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AllAtomsInsideSphereAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "Descriptors/AtomShapeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "Shapes/ShapeOps.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAllAtomsInsideSphereState : public ActionState {
+public:
+  SelectionAllAtomsInsideSphereState(std::vector<atom*> _selectedAtoms, const Vector &_position, const double _radius) :
+    selectedAtoms(_selectedAtoms),
+    position(_position),
+    radius(_radius)
+  {}
+  std::vector<atom*> selectedAtoms;
+  Vector position;
+  double radius;
+};
+
+const char SelectionAllAtomsInsideSphereAction::NAME[] = "select-atoms-inside-sphere";
+
+SelectionAllAtomsInsideSphereAction::SelectionAllAtomsInsideSphereAction() :
+  Action(NAME)
+{}
+
+SelectionAllAtomsInsideSphereAction::~SelectionAllAtomsInsideSphereAction()
+{}
+
+void SelectionAllAtomsInsideSphere(const Vector &position, const double radius) {
+  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideSphereAction::NAME, radius);
+  ValueStorage::getInstance().setCurrentValue("position", position);
+  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideSphereAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAllAtomsInsideSphereAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAllAtomsInsideSphereAction::performCall() {
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+  double radius = 0.;
+  Vector position;
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, radius);
+  ValueStorage::getInstance().queryCurrentValue("position", position);
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a sphere at " << position << " with radius " << radius << "." << endl);
+  Shape s = translate(resize(Sphere(),radius),position);
+  World::getInstance().selectAllAtoms(AtomByShape(s));
+  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(selectedAtoms, position, radius));
+}
+
+Action::state_ptr SelectionAllAtomsInsideSphereAction::performUndo(Action::state_ptr _state) {
+  SelectionAllAtomsInsideSphereState *state = assert_cast<SelectionAllAtomsInsideSphereState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+}
+
+Action::state_ptr SelectionAllAtomsInsideSphereAction::performRedo(Action::state_ptr _state){
+  SelectionAllAtomsInsideSphereState *state = assert_cast<SelectionAllAtomsInsideSphereState*>(_state.get());
+
+  Shape s = translate(resize(Sphere(),state->radius),state->position);
+  World::getInstance().selectAllAtoms(AtomByShape(s));
+
+  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+}
+
+bool SelectionAllAtomsInsideSphereAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllAtomsInsideSphereAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAllAtomsInsideSphereAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * AllAtomsInsideSphereAction.hpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ALLATOMSINSIDESPHEREACTION_HPP_
+#define ALLATOMSINSIDESPHEREACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class Vector;
+
+void SelectionAllAtomsInsideSphere();
+
+class SelectionAllAtomsInsideSphereAction : public Action {
+  friend void SelectionAllAtomsInsideSphere(const Vector &position, const double radius);
+
+public:
+  SelectionAllAtomsInsideSphereAction();
+  virtual ~SelectionAllAtomsInsideSphereAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ALLATOMSINSIDESPHEREACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,106 @@
+/*
+ * AllAtomsOfMoleculeAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "atom.hpp"
+#include "molecule.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAllAtomsOfMoleculeState : public ActionState {
+public:
+  SelectionAllAtomsOfMoleculeState(std::vector<atom*> _selectedAtoms, molecule *_mol) :
+    selectedAtoms(_selectedAtoms),
+    mol(_mol)
+  {}
+  std::vector<atom*> selectedAtoms;
+  molecule *mol;
+};
+
+const char SelectionAllAtomsOfMoleculeAction::NAME[] = "select-molecules-atoms";
+
+SelectionAllAtomsOfMoleculeAction::SelectionAllAtomsOfMoleculeAction() :
+  Action(NAME)
+{}
+
+SelectionAllAtomsOfMoleculeAction::~SelectionAllAtomsOfMoleculeAction()
+{}
+
+void SelectionAllAtomsOfMolecule() {
+  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsOfMoleculeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAllAtomsOfMoleculeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAllAtomsOfMoleculeAction::performCall() {
+  molecule *mol = NULL;
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms of molecule " << mol->getName() << "." << endl);
+  World::getInstance().selectAtomsOfMolecule(mol);
+  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(selectedAtoms, mol));
+}
+
+Action::state_ptr SelectionAllAtomsOfMoleculeAction::performUndo(Action::state_ptr _state) {
+  SelectionAllAtomsOfMoleculeState *state = assert_cast<SelectionAllAtomsOfMoleculeState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+}
+
+Action::state_ptr SelectionAllAtomsOfMoleculeAction::performRedo(Action::state_ptr _state){
+  SelectionAllAtomsOfMoleculeState *state = assert_cast<SelectionAllAtomsOfMoleculeState*>(_state.get());
+
+  World::getInstance().selectAtomsOfMolecule(state->mol);
+
+  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+}
+
+bool SelectionAllAtomsOfMoleculeAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllAtomsOfMoleculeAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAllAtomsOfMoleculeAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,36 @@
+/*
+ * AllAtomsOfMoleculeAction.hpp
+ *
+ *  Created on: Aug 09, 2010
+ *      Author: heber
+ */
+
+#ifndef ALLATOMSOFMOLECULEACTION_HPP_
+#define ALLATOMSOFMOLECULEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+void SelectionAllAtomsOfMolecule();
+
+class SelectionAllAtomsOfMoleculeAction : public Action {
+  friend void SelectionAllAtomsOfMolecule();
+
+public:
+  SelectionAllAtomsOfMoleculeAction();
+  virtual ~SelectionAllAtomsOfMoleculeAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ALLATOMSOFMOLECULEACTION_HPP_ */
Index: src/Actions/SelectionAction/AllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,99 @@
+/*
+ * AllMoleculesAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AllMoleculesAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAllMoleculesState : public ActionState {
+public:
+  SelectionAllMoleculesState(std::vector<molecule*> selectedMolecules) :
+    selectedMolecules(selectedMolecules)
+  {}
+  std::vector<molecule*> selectedMolecules;
+};
+
+const char SelectionAllMoleculesAction::NAME[] = "select-all-molecules";
+
+SelectionAllMoleculesAction::SelectionAllMoleculesAction() :
+  Action(NAME)
+{}
+
+SelectionAllMoleculesAction::~SelectionAllMoleculesAction()
+{}
+
+void SelectionAllMolecules() {
+  ActionRegistry::getInstance().getActionByName(SelectionAllMoleculesAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAllMoleculesAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAllMoleculesAction::performCall() {
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all molecules." << endl);
+  World::getInstance().selectAllMolecules(AllMolecules());
+  return Action::state_ptr(new SelectionAllMoleculesState(selectedMolecules));
+}
+
+Action::state_ptr SelectionAllMoleculesAction::performUndo(Action::state_ptr _state) {
+  SelectionAllMoleculesState *state = assert_cast<SelectionAllMoleculesState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(new SelectionAllMoleculesState(state->selectedMolecules));
+}
+
+Action::state_ptr SelectionAllMoleculesAction::performRedo(Action::state_ptr _state){
+  SelectionAllMoleculesState *state = assert_cast<SelectionAllMoleculesState*>(_state.get());
+
+  World::getInstance().selectAllMolecules(AllMolecules());
+
+  return Action::state_ptr(new SelectionAllMoleculesState(state->selectedMolecules));
+}
+
+bool SelectionAllMoleculesAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllMoleculesAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAllMoleculesAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllMoleculesAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,36 @@
+/*
+ * AllMoleculesAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef ALLMOLECULESSACTION_HPP_
+#define ALLMOLECULESSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+void SelectionAllMolecules();
+
+class SelectionAllMoleculesAction : public Action {
+  friend void SelectionAllMolecules();
+
+public:
+  SelectionAllMoleculesAction();
+  virtual ~SelectionAllMoleculesAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ALLMOLECULESSACTION_HPP_ */
Index: src/Actions/SelectionAction/AtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/AtomByElementAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AtomByElementAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,107 @@
+/*
+ * AtomByElementAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AtomByElementAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomTypeDescriptor.hpp"
+#include "atom.hpp"
+#include "element.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAtomByElementState : public ActionState {
+public:
+  SelectionAtomByElementState(std::vector<atom*> _selectedAtoms, const element *_elemental) :
+    selectedAtoms(_selectedAtoms),
+    elemental(_elemental)
+  {}
+  std::vector<atom*> selectedAtoms;
+  const element *elemental;
+};
+
+const char SelectionAtomByElementAction::NAME[] = "select-atom-by-element";
+
+SelectionAtomByElementAction::SelectionAtomByElementAction() :
+  Action(NAME)
+{}
+
+SelectionAtomByElementAction::~SelectionAtomByElementAction()
+{}
+
+void SelectionAtomByElement(const element &_element) {
+  ValueStorage::getInstance().setCurrentValue(SelectionAtomByElementAction::NAME, _element);
+  ActionRegistry::getInstance().getActionByName(SelectionAtomByElementAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAtomByElementAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAtomByElementAction::performCall() {
+  const element *elemental;
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting atoms of type " << *elemental << endl);
+  World::getInstance().selectAllAtoms(AtomByType(elemental));
+  return Action::state_ptr(new SelectionAtomByElementState(selectedAtoms,elemental));
+}
+
+Action::state_ptr SelectionAtomByElementAction::performUndo(Action::state_ptr _state) {
+  SelectionAtomByElementState *state = assert_cast<SelectionAtomByElementState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionAtomByElementAction::performRedo(Action::state_ptr _state){
+  SelectionAtomByElementState *state = assert_cast<SelectionAtomByElementState*>(_state.get());
+
+  World::getInstance().selectAllAtoms(AtomByType(state->elemental));
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionAtomByElementAction::canUndo() {
+  return true;
+}
+
+bool SelectionAtomByElementAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAtomByElementAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AtomByElementAction.hpp
===================================================================
--- src/Actions/SelectionAction/AtomByElementAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AtomByElementAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * AtomByElementAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef ATOMBYELEMENTACTION_HPP_
+#define ATOMBYELEMENTACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class element;
+
+void SelectionAtomByElement(const element &_element);
+
+class SelectionAtomByElementAction : public Action {
+  friend void SelectionAtomByElement(const element &_element);
+
+public:
+  SelectionAtomByElementAction();
+  virtual ~SelectionAtomByElementAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ATOMBYELEMENTACTION_HPP_ */
Index: src/Actions/SelectionAction/AtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AtomByIdAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,106 @@
+/*
+ * AtomByIdAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AtomByIdAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAtomByIdState : public ActionState {
+public:
+  SelectionAtomByIdState(atom* _walker) :
+    walker(_walker)
+  {}
+  atom* walker;
+};
+
+const char SelectionAtomByIdAction::NAME[] = "select-atom-by-id";
+
+SelectionAtomByIdAction::SelectionAtomByIdAction() :
+  Action(NAME)
+{}
+
+SelectionAtomByIdAction::~SelectionAtomByIdAction()
+{}
+
+void SelectionAtomById(atom *_atom) {
+  ValueStorage::getInstance().setCurrentValue(SelectionAtomByIdAction::NAME, _atom);
+  ActionRegistry::getInstance().getActionByName(SelectionAtomByIdAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAtomByIdAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAtomByIdAction::performCall() {
+  atom *Walker = NULL;
+
+  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
+
+  if (!World::getInstance().isSelected(Walker)) {
+    DoLog(1) && (Log() << Verbose(1) << "Selecting atom " << *Walker << endl);
+    World::getInstance().selectAtom(Walker);
+    return Action::state_ptr(new SelectionAtomByIdState(Walker));
+  } else {
+    return Action::success;
+  }
+}
+
+Action::state_ptr SelectionAtomByIdAction::performUndo(Action::state_ptr _state) {
+  SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
+
+  if (state->walker != NULL)
+    World::getInstance().unselectAtom(state->walker);
+
+  return Action::state_ptr(new SelectionAtomByIdState(state->walker));
+}
+
+Action::state_ptr SelectionAtomByIdAction::performRedo(Action::state_ptr _state){
+  SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
+
+  if (state->walker != NULL)
+    World::getInstance().selectAtom(state->walker);
+
+  return Action::state_ptr(new SelectionAtomByIdState(state->walker));
+}
+
+bool SelectionAtomByIdAction::canUndo() {
+  return true;
+}
+
+bool SelectionAtomByIdAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAtomByIdAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AtomByIdAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * AtomByIdAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef ATOMBYIDACTION_HPP_
+#define ATOMBYIDACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class atom;
+
+void SelectionAtomById(atom *_atom);
+
+class SelectionAtomByIdAction : public Action {
+  friend void SelectionAtomById(atom *_atom);
+
+public:
+  SelectionAtomByIdAction();
+  virtual ~SelectionAtomByIdAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ATOMBYIDACTION_HPP_ */
